/***************************************************************************
                          WMAnsiEd.cpp  -  description
                             -------------------
    begin                : Mon Apr 17 17:11:17 CEST 2000
    copyright            : (C) 2000 by Walter Schreppers
    email                : walle@easynet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "WMAnsiEd.h"
#include "IBMFont.h"

#include <iostream.h>

#include <qevent.h>
#include <qpainter.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qtooltip.h>
#include <qrect.h>
#include <qpoint.h>
#include <qmessagebox.h>
#include <qfiledialog.h>
#include <qcursor.h>
#include <qimage.h>
#include <qstrlist.h>
#include <qpopupmenu.h>
#include <qintdict.h>
#include <qpixmap.h>
#include <iostream.h>
#include "canvas.h"
#include <qcombobox.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qmenubar.h>
#include <qcheckbox.h>
#include "palette.h"

void WMAnsiEd::keyPressEvent( QKeyEvent *e) {
	if((e->ascii()>=32)&&(e->ascii()<=255)){
	  combCHAR->setCurrentItem(e->ascii()-32);
	  canvas.setText(e->ascii());
	}
}


WMAnsiEd::WMAnsiEd( QWidget *parent, const char *name )
    : QMainWindow( parent, name ), canvas( this )
{
    setCentralWidget( &canvas );
    
    QPopupMenu *load = new QPopupMenu(this);
      //load->insertTearOffHandle();
      load->insertItem("Open Ansi",this,SLOT(slotLoadAnsi()));
      load->insertItem("Open Ascii",this,SLOT(slotLoadAscii()));  

    QPopupMenu *save = new QPopupMenu(this);
      //save->insertTearOffHandle();
      save->insertItem("Save as Ansi",this,SLOT(slotSaveAnsi()));
      save->insertItem("Save as Ascii",this,SLOT(slotSaveAscii()));
      
    QPopupMenu *file = new QPopupMenu(this );
    menuBar()->insertItem( "&File", file );
       file->insertItem( "&Open", load, CTRL+Key_O );
       file->insertItem( "&Save", save, CTRL+Key_S );
    
    QPopupMenu *move = new QPopupMenu(this);
      //move->insertTearOffHandle();
      move->insertItem("Move &Left",this,SLOT(slotMoveLeft()),CTRL+Key_L);
      move->insertItem("Move &Right",this,SLOT(slotMoveRight()),CTRL+Key_R);
      move->insertItem("Move &Up",this,SLOT(slotMoveUp()),CTRL+Key_U);
      move->insertItem("Move &Down",this,SLOT(slotMoveDown()),CTRL+Key_D);
      move->insertItem("&HCenter",this,SLOT(slotHCenter()),CTRL+Key_H);
      move->insertItem("&VCenter",this,SLOT(slotVCenter()),CTRL+Key_V);
      
      
    QPopupMenu *edit = new QPopupMenu(this );
    menuBar()->insertItem( "&Edit", edit );
       edit->insertItem( "&Clear Screen", this,SLOT(slotClear()) ,CTRL+Key_X );
       edit->insertItem("&Move",move, CTRL+Key_M);
    
    
    QPopupMenu *drawmode = new QPopupMenu(this);
      //save->insertTearOffHandle();
      drawmode->insertItem("Plot",this,SLOT(slotPlot()));
      drawmode->insertItem("Line",this,SLOT(slotLine()));
      drawmode->insertItem("Box",this,SLOT(slotBox()));
      drawmode->insertItem("Filled Box",this,SLOT(slotFBox()));
      drawmode->insertItem("Ellipse",this,SLOT(slotCircle()));
      drawmode->insertItem("Filled Ellipse",this,SLOT(slotFCircle()));
      drawmode->insertItem("Scribble",this,SLOT(slotScribble()));
      drawmode->insertItem("Double Scribble",this,SLOT(slotDScribble()));
    
    QPopupMenu *options = new QPopupMenu(this );
    menuBar()->insertItem("&Options", options );
       options->insertItem("Draw Mode", drawmode);
       //options->insertItem("&Move",move, CTRL+Key_M);
    
    
     QPopupMenu *help = new QPopupMenu( this );
     menuBar()->insertItem("&Help", help );
       help->insertItem( "&About", this, SLOT(slotAbout()), CTRL+Key_A );
    
    
    
  //toolbar met char,bgcolor,fgcolor      
    QToolBar *tools = new QToolBar( this );
    tools->move(0,20);
    
    /*
     deze staan nu in het menu
      bSave = new QToolButton( tools, "Save", "Save as PNG image", this, SLOT( slotSave() ), tools );
      bSave = new QToolButton(tools,SLOT(slotSave()));
      bSave->setText( "Save as..." );
  
      bClear = new QToolButton( QPixmap(), "Clear Screen", "Clear Screen", this, SLOT( slotClear() ), tools );
      bClear->setText( "Clear Screen" );
    */
    
    tools->addSeparator();
    
       
    // Character input

    IBMFont font;    
    combCHAR = new QComboBox(tools,"Character Input");
    QToolTip::add( combCHAR, "Character Input" );   
    combCHAR->setFixedSize(40,25);
    for(int i=32;i<257;i++){
      //combCHAR->insertItem(QString(QChar(i)));
      combCHAR->insertItem(font.getChar(i));
    }
        
    combCHAR->setCurrentItem(3);
    connect( combCHAR, SIGNAL( activated( int ) ), this, SLOT( slotComboCHARActivated(int ) ) );     
 

    tools->addSeparator();


    #define ADD_LABEL( str, w, h )    \
    { QLabel *label = new QLabel(str,tools); \
      label->setFixedSize(w,h);\
      label->setAlignment(AlignCenter|AlignVCenter); }
                
  //Background colors


    
    QPixmap p( 10, 15, -1, QPixmap::defaultOptimization());
    ADD_LABEL("BG",30,25);
    combBG = new QComboBox(tools,"Background Color");
    //combBG->setFixedSize(40,25);
    QToolTip::add( combBG, "Background Color" );   
      
    for(int i=0;i<8;i++){
      p.fill(Palette(i).getColor());
      combBG->insertItem(p);
    }
    
    

    connect( combBG, SIGNAL( activated( int ) ), this, SLOT( slotComboBGActivated(int ) ) );   

    tools->addSeparator();


  //Foreground colors
  
    ADD_LABEL("FG",30,25);
    combFG = new QComboBox(tools,"Foreground Color");
    combFG->setFixedSize(40,25);
    QToolTip::add( combFG, "Foreground Color" );   
        
    for(int i=0;i<16;i++){
      p.fill(Palette(i).getColor());
      combFG->insertItem(p);
    }
    combFG->setCurrentItem(7);
    connect( combFG, SIGNAL( activated( int ) ), this, SLOT( slotComboFGActivated(int ) ) );   
    
  tools->addSeparator();
    
    ADD_LABEL("CLR",50,25);
    chkCLR = new QCheckBox(tools,"ClearScr Char");
    QToolTip::add( chkCLR, "Insert clearscreen code" );   
    chkCLR->setChecked(FALSE);
    
  tools->addSeparator();
    
    ADD_LABEL("HOME",60,25);
    chkHOME = new QCheckBox(tools,"Home Char");
    QToolTip::add( chkHOME, "Insert curser home code" );   
    chkHOME->setChecked(FALSE);  
  
  tools->addSeparator();
  
  
  //initiele char zetten als spatie
    canvas.setText(35);
}


void WMAnsiEd::slotComboBGActivated(int index){
  canvas.setBackground(index);
}


void WMAnsiEd::slotComboFGActivated(int index){
  canvas.setForeground(index);
}

void WMAnsiEd::slotComboCHARActivated(int index){
  //cout<<index<<endl;
  canvas.setText(index+32);
}



void WMAnsiEd::slotSaveAnsi()
{

    QString filename = QFileDialog::getSaveFileName( QString::null, QString( "*.%1" ).arg(QString("ansi")), this );
    if ( !filename.isEmpty() ){
        ofstream file((const char*)filename);
        canvas.t.writeAnsi(file,chkCLR->isChecked(),chkHOME->isChecked());
    }
}


void WMAnsiEd::slotSaveAscii()
{

    QString filename = QFileDialog::getSaveFileName( QString::null, QString( "*.%1" ).arg(QString("ascii")), this );
    if ( !filename.isEmpty() ){
        ofstream file((const char*)filename);
        canvas.t.writeAscii(file);
    }
}


void WMAnsiEd::slotLoadAscii()
{

    QString filename = QFileDialog::getOpenFileName( QString::null, QString( "*.%1" ).arg(QString("ascii")), this );
    if ( !filename.isEmpty() ){
        ifstream file((const char*)filename);
        canvas.t.loadAscii(file);
        canvas.updateScreen();
    }
}


void WMAnsiEd::slotLoadAnsi()
{

    QString filename = QFileDialog::getOpenFileName( QString::null, QString( "*.%1" ).arg(QString("ansi")), this );
    if ( !filename.isEmpty() ){
        ifstream file((const char*)filename);
        canvas.t.loadAnsi(file);
        chkCLR->setChecked(canvas.t.getScrClear());  
        chkHOME->setChecked(canvas.t.getScrHome());
        canvas.updateScreen();
    }
}



void WMAnsiEd::slotWidth( int w )
{
    canvas.setPenWidth( w );
}

void WMAnsiEd::slotClear()
{
    canvas.clearScreen();
}

void WMAnsiEd::slotAbout()
{
   QMessageBox::about( this, "WMAnsiEd",
         "          WMAnsiEd 0.3              \n\n"
         "  Programmed by: wALLe & MoobY      \n\n"  
         "  - wALLe  (Walter Schreppers)      \n"
         "     mail: walle@easynet.be         \n\n" 
         "  - MoobY (Anthony Liekens)         \n"
         "     mail: mooby@nerdhero.org       "
         );
}



void WMAnsiEd::slotMoveLeft(){
  canvas.t.moveLeft();
  canvas.updateScreen();
}


void WMAnsiEd::slotMoveRight(){
  canvas.t.moveRight();
  canvas.updateScreen();
}



void WMAnsiEd::slotMoveUp(){
  canvas.t.moveUp();
  canvas.updateScreen();
}


void WMAnsiEd::slotMoveDown(){
  canvas.t.moveDown();
  canvas.updateScreen();
}

void WMAnsiEd::slotHCenter(){
  canvas.t.moveHCenter();
  canvas.updateScreen();
}

void WMAnsiEd::slotVCenter(){
  canvas.t.moveVCenter();
  canvas.updateScreen();
}

void WMAnsiEd::slotPlot(){
  canvas.setDrawMode(plot);
}

void WMAnsiEd::slotLine(){
  canvas.setDrawMode(line);
}
void WMAnsiEd::slotBox(){
  canvas.setDrawMode(box);
}
void WMAnsiEd::slotFBox(){
  canvas.setDrawMode(fbox);
}
void WMAnsiEd::slotCircle(){
  canvas.setDrawMode(circle);
}
void WMAnsiEd::slotFCircle(){
  canvas.setDrawMode(fcircle);
}
void WMAnsiEd::slotScribble(){
  canvas.setDrawMode(scribble);
}
void WMAnsiEd::slotDScribble(){
  canvas.setDrawMode(dscribble);
}




